{ 
               PEANO.PAS                                       
                     ,                                  
               BP 7.0                                          
  
               -  , -  
                         ,   .                         
  
                    "   "                    
   }

PROGRAM PeanoCurve;
USES  Crt, Graph;
CONST Nord  = 1;
      Est   = 2;
      South = 4;
      West  = 8;

PROCEDURE Plot(Dir, Size : Integer);
  Begin
     Case Dir of
       Nord          : LineRel(0,-Size);
       Est           : LineRel(Size,0);
       South         : LineRel(0,Size);
       West          : LineRel(-Size,0);
       Nord  + Est   : LineRel(Size,-Size);
       Est   + South : LineRel(Size,Size);
       South + West  : LineRel(-Size,Size);
       West  + Nord  : LineRel(-Size,-Size)
     End
  End;

PROCEDURE Peano(U,R,D,L,i,Size : Integer); {     }
  Procedure Pea(U,R,D,L,i,Size : Integer);
    Begin
      Peano(U,R,D,L,i,Size); Plot(R,Size);
      Peano(D,R,U,L,i,Size); Plot(R,Size);
      Peano(U,R,D,L,i,Size)
    End;
  Begin
    If i > 0 then
      begin
        Dec(i);
        Pea(U,R,D,L,i,Size); Plot(U,Size);
        Pea(U,L,D,R,i,Size); Plot(U,Size);
        Pea(U,R,D,L,i,Size)
      end
  End;

PROCEDURE Hilbert(U,R,D,L,i,Size : Integer); {     }
  Begin
    If i > 0 then
      begin
        Dec(i);
        Hilbert(R,U,L,D,i,Size); Plot(U,Size);
        Hilbert(U,R,D,L,i,Size); Plot(R,Size);
        Hilbert(U,R,D,L,i,Size); Plot(D,Size);
        Hilbert(L,D,R,U,i,Size)
      end
  End;

PROCEDURE Sierpinski(N,Size : Integer); {     }
   Procedure Sierpin(U,R,D,L,i,Size : Integer);
     Begin
       If i > 0 then
         begin
           Dec(i);
           Sierpin(U,R,D,L,i,Size); Plot(U+R,Size);
           Sierpin(L,U,R,D,i,Size); Plot(R,Size+Size);
           Sierpin(R,D,L,U,i,Size); Plot(D+R,Size);
           Sierpin(U,R,D,L,i,Size)
         end
     End;
  Begin
     Sierpin(Nord,Est,South,West,N,Size); Plot(Nord+Est,Size);
     Sierpin(West,Nord,Est,South,N,Size); Plot(Nord+West,Size);
     Sierpin(South,West,Nord,Est,N,Size); Plot(South+West,Size);
     Sierpin(Est,South,West,Nord,N,Size); Plot(South+Est,Size)
  End;

PROCEDURE Wirth(N,Size : Integer); {     }
   Procedure Wir(U,R,D,L,i,Size : Integer);
     Begin
       If i > 0 then
         begin
           Dec(i);
           Wir(U,R,D,L,i,Size); Plot(U,Size); Plot(R,Size);
           Wir(L,U,R,D,i,Size); Plot(R,Size);
           Wir(R,D,L,U,i,Size); Plot(R,Size); Plot(D,Size);
           Wir(U,R,D,L,i,Size)
         end
       else Plot(R,Size)
     End;
  Begin
     Plot(Est,Size);   Plot(South,Size); Wir(Nord,Est,South,West,N,Size);
     Plot(Nord,Size);  Plot(Est,Size);   Wir(West,Nord,Est,South,N,Size);
     Plot(West,Size);  Plot(Nord,Size);  Wir(South,West,Nord,Est,N,Size);
     Plot(South,Size); Plot(West,Size);  Wir(Est,South,West,Nord,N,Size)
  End;

PROCEDURE Wait;
  Begin
     Repeat Until ReadKey = #13;
     ClearViewPort
  End;

VAR GrD, GrM : Integer;
BEGIN
   GrD := Detect;
   InitGraph(GrD,GrM,'C:\BP\BGI');

   OutTextXY(210,20,'Peano''s curve, N=4, Size=5');
   MoveTo(110,445); Peano(Nord,Est,South,West,4,5); Wait;

   OutTextXY(200,20,'Hilbert''s curve, N=6, Size=6');
   MoveTo(120,430); Hilbert(Nord,Est,South,West,6,6); Wait;

   OutTextXY(190,20,'Sierpinski''s curve, N=5, Size=3');
   MoveTo(120,430); Sierpinski(5,3); Wait;

   OutTextXY(210,20,'Wirth''s curve, N=5, Size=3');
   MoveTo(120,430); Wirth(5,3); Wait;

   CloseGraph
END.