{ 
               EXPRTREE.PAS                                    
                     ,                                  
               BP 7.0                                          
  
                     
                           ,   .            
  
                    "   "                    
   }

PROGRAM ExpressionInTree;
USES Crt;
CONST EndChar = #0; {      }
TYPE TConstType = Integer; {    }
     TTip = (Operator, Variable, Constant); {      }

     PExpTree = ^TExpTree; { ,   }
     TExpTree = Record
        Left, Right : PExpTree;
        Case Tip : TTip of
          Operator : (Oper : Char);
          Variable : ();
          Constant : (Cons : TConstType)
     End;


{ 
                
   }

PROCEDURE BuildTree(Expr : String; Var ExpTree : PExpTree);
  {         }
Var Sym    : Char;
    CurPos : Byte;

 Procedure Error; {        }
   Begin WriteLn(' !'); Halt End;

 Procedure NextSym; {      }
   Begin
     {    }
     While (CurPos <= Length(Expr)) and (Expr[CurPos] = ' ') do Inc(CurPos);
     {      --->  }
     If CurPos > (Length(Expr)+1) then Error
     {  -     }
     else begin Sym := UpCase(Expr[CurPos]); Inc(CurPos) end
   End;

 Function GetConstant : TConstType; {      }
 Var Znak   : Char;
     Rezult : TConstType;
   Begin
     If Sym in ['+','-'] then begin Znak := Sym; NextSym end else Znak := '+';
     If not (Sym in ['0'..'9']) then Error;
     Rezult := 0;
     While Sym in ['0'..'9'] do
       begin
         Rezult := Rezult*10 + (Ord(Sym) - Ord('0'));
         NextSym
       end;
     If Znak = '-' then Rezult := -Rezult;
     GetConstant := Rezult
   End;

 Procedure Expression(Var ExpTree : PExpTree); Forward;

 Procedure Factor(Var ExpTree : PExpTree);
   Begin
     If Sym = '(' then
       begin
         NextSym; Expression(ExpTree);
         If Sym = ')' then NextSym else Error
       end
     else
       begin
         New(ExpTree); ExpTree^.Left := nil; ExpTree^.Right := nil;
         If Sym = 'X' then begin ExpTree^.Tip := Variable; NextSym end
         else
           If Sym in ['0'..'9','+','-'] then
             begin ExpTree^.Tip := Constant; ExpTree^.Cons := GetConstant end
           else If Sym <> EndChar then Error
       end
   End; { Factor }

 Procedure Term(Var ExpTree : PExpTree);
 Var Op        : Char;
     Arg1,Arg2 : PExpTree;
   Begin
     Factor(Arg1); ExpTree := Arg1;
     While Sym in ['*','/'] do
       begin
         Op := Sym; NextSym;
         If Sym = EndChar then Error;
         Factor(Arg2);
         {   }
         New(ExpTree);
         With ExpTree^ do
           begin Tip := Operator; Oper := Op; Left := Arg1; Right := Arg2 end;
         Arg1 := ExpTree
       end
   end; { Term }

 Procedure Expression(Var ExpTree : PExpTree);
 Var Op        : Char;
     Arg1,Arg2 : PExpTree;
   Begin
     Term(Arg1); ExpTree := Arg1;
     While Sym in ['+','-'] do
       begin
         Op := Sym; NextSym;
         If Sym = EndChar then Error;
         Term(Arg2);
         {   }
         New(ExpTree);
         With ExpTree^ do
           begin Tip := Operator; Oper := Op; Left := Arg1; Right := Arg2 end;
         Arg1 := ExpTree
       end
   End; { Expression }

Begin { BuildTree }
  Expr := Expr + EndChar; CurPos := 1;
  NextSym;
  Expression(ExpTree);
  If Sym <> EndChar then Error
End; { BuildTree }


{ 
        ,   90    
   }

PROCEDURE PrintTree(Tree : PExpTree; Len : Byte);
  {    ,   90  }
Var I : Byte;
  Begin
     If Tree <> nil then
       With Tree^ do
         begin
           PrintTree(Tree^.Left,Len+1);
           For I := 1 to Len do Write('   ');
           Case Tree^.Tip of
             Operator : WriteLn(Oper);
             Variable : WriteLn('X');
             Constant : WriteLn(Cons)
           End;
           PrintTree(Tree^.Right,Len+1)
         end
  End;


{ 
       ,      
   }

PROCEDURE PrintExpr(Tree : PExpTree);
  {  ,   ,     }

  Procedure Print2(Tree : PExpTree);
    Begin
      With Tree^ do
        If (Tip = Operator) and (Oper in ['+','-']) then
          begin Write('('); PrintExpr(Tree); Write(')') end
        else PrintExpr(Tree)
    End;

Var I : Byte;
  Begin
     If Tree <> nil then
       With Tree^ do
         Case Tip of
           Variable : Write('X');
           Constant : Write(Cons);
           Operator :
             Case Oper of
               '+','-' : begin PrintExpr(Left);Write(Oper);PrintExpr(Right) end;
               {      - ! }
               '*','/' : begin Print2(Left); Write(Oper); Print2(Right) end;
             End { Case }
         End { Case }
  End;


{ 
                
   }

PROCEDURE ShowTree(ExpTree : PExpTree);
 {      ,     }

Const  {   }
  DAgr=#192; {''}
  VLgr=#211; {''}
  HLgr=#196; {''}
  RPgr=#195; {''}
  DPgr=#194; {''}

Const
  Len      = 5;
  MaxLevel = 100;

Var
  Level : Word;
  nl    : Boolean;
  v     : Array[1..MaxLevel] of Byte;

 Procedure Show(ExpTree : PExpTree);
 Var I  : Word;
     St : String;
   Begin
     If nl then
       begin
         WriteLn;
         For I := 1 to Level-2 do
           If v[I] > 0 then Write(VLgr:Len,' ') else Write(' ':Len+1);
         If v[Level-1] = 2 then begin Write(RPgr:Len,HLgr); v[level-1]:=1 end
         else If v[Level-1] = 1 then
           begin Write(DAgr:Len,HLgr); v[Level-1] := 0 end
         else Write(' ':Len+1);
         nl := False
       end;

    If ExpTree^.Tip = Operator then v[level] := 1;
    Inc(Level);

    Case ExpTree^.Tip of
      Operator : st := ExpTree^.Oper;
      Variable : st := 'X';
      Constant : Str(ExpTree^.Cons,St)
    End;
    For I := 1 to Len - Length(st) - 1 do Write(HLgr);
    Write(' ',st,' ');

    If ExpTree^.Left <> nil then Show(ExpTree^.Left);   {  }
    If ExpTree^.Right <> nil then Show(ExpTree^.Right); {  }

    Dec(Level); nl := True

   End; { Show }

Var I : Word;
  Begin { ShowTree }
    For I := 1 to MaxLevel do v[I] := 0;
    Level := 1; nl := False;
    Show(ExpTree); WriteLn
  End; { ShowTree }


{ 
        ,     
   }

FUNCTION Calculate(T : PExpTree; ValX : TConstType) : TConstType;
{    ,        X }
  Begin
    If T = nil then Calculate := 0
    else
      With T^ do
        Case Tip of
          Constant : Calculate := Cons;
          Variable : Calculate := ValX;
          Operator :
            Case Oper of
              '+' : Calculate := Calculate(Left,ValX)  +  Calculate(Right,ValX);
              '-' : Calculate := Calculate(Left,ValX)  -  Calculate(Right,ValX);
              '*' : Calculate := Calculate(Left,ValX)  *  Calculate(Right,ValX);
              '/' : Calculate := Calculate(Left,ValX) div Calculate(Right,ValX);
            End { Case }
        End { Case }
  End;


{ 
       ,     
   }

PROCEDURE DeleteTree(Var Tree : PExpTree); {    }
  Begin
    If Tree <> nil then
      begin DeleteTree(Tree^.Left); DeleteTree(Tree^.Right); Dispose(Tree);
            Tree := nil end
  End;

FUNCTION Equal(T : PExpTree; X : TConstType) : Boolean;
  {   ,   T  -   X }
  Begin
    If T <> nil then
      With T^ do Equal := (Tip = Constant) and (Cons = X)
    else Equal := False
  End;

PROCEDURE Clear(Var T : PExpTree); {       T }
  Begin
    With T^ do
      begin Tip := Constant; Cons := 0; DeleteTree(Left); DeleteTree(Right) end
  End;

PROCEDURE ClearLeft(Var T : PExpTree); {    () }
Var P : PExpTree;
  Begin P := T; T := T^.Right; Dispose(P^.Left); Dispose(P) End;

PROCEDURE ClearRight(Var T : PExpTree); {    () }
Var P : PExpTree;
  Begin P := T; T := T^.Left; Dispose(P^.Right); Dispose(P) End;

PROCEDURE Simple(Var T : PExpTree); {      
   (T+0)-->T, (T-0)-->T, (T*1)-->T, (T*0)-->0, (0/T)-->0, (T/1)-->T
   (0+T)-->T           , (1*T)-->T, (0*T)-->0
}
  Begin
    If T <> nil then
      With T^ do
        begin
          Simple(Left); Simple(Right);
          If Tip = Operator then
            Case Oper of
              '+' : If Equal(Left,0) then ClearLeft(T)
                    else If Equal(Right,0) then ClearRight(T);
              '-' : If Equal(Right,0) then ClearRight(T);
              '*' : If Equal(Left,0) or Equal(Right,0) then Clear(T)
                    else If Equal(Left,1) then ClearLeft(T)
                    else If Equal(Right,1) then ClearRight(T);
              '/' : If Equal(Left,0) then Clear(T)
                    else If Equal(Right,1) then ClearRight(T)
            End { Case }
        end
  End;

PROCEDURE Check4Consts(T : PExpTree);
  {          }
  Begin
    If (T^.Left  <> nil) and (T^.Left^.Tip  = Constant) and
       (T^.Right <> nil) and (T^.Right^.Tip = Constant) then
         begin
           T^.Tip := Constant;
           Case T^.Oper of
             '+' : T^.Cons := T^.Left^.Cons  +  T^.Right^.Cons;
             '-' : T^.Cons := T^.Left^.Cons  -  T^.Right^.Cons;
             '*' : T^.Cons := T^.Left^.Cons  *  T^.Right^.Cons;
             '/' : T^.Cons := T^.Left^.Cons div T^.Right^.Cons
           End;
           Dispose(T^.Left); T^.Left := nil;
           Dispose(T^.Right); T^.Right := nil
         end
  End;

FUNCTION IsEqualTree(Tree1,Tree2 : PExpTree) : Boolean;
  {           }
  Begin
    {      ,    }
    If (Tree1 = nil) and (Tree2 = nil) then IsEqualTree := True
    {        ,    }
    else If ((Tree1 <> nil) and (Tree2 = nil)) or
            ((Tree1 = nil) and (Tree2 <> nil)) then IsEqualTree := False
        {     ... }
         else If (Tree1^.Tip <> Tree2^.Tip) then IsEqualTree := False
              else { Tree1^.Tip = Tree2^.Tip }
                 Case Tree1^.Tip of
                   Variable : IsEqualTree := True;
                   Constant : IsEqualTree := (Tree1^.Cons = Tree2^.Cons);
                   Operator :
                     If Tree1^.Oper <> Tree2^.Oper then IsEqualTree := False
                     else If Tree1^.Oper in ['-','/'] then
                         IsEqualTree := IsEqualTree(Tree1^.Left,Tree2^.Left)
                                   and IsEqualTree(Tree1^.Right,Tree2^.Right)
                       else {     ... }
                         IsEqualTree :=
                             (IsEqualTree(Tree1^.Left,Tree2^.Left) and
                              IsEqualTree(Tree1^.Right,Tree2^.Right))
                           or
                             (IsEqualTree(Tree1^.Left,Tree2^.Right) and
                              IsEqualTree(Tree1^.Right,Tree2^.Left))
                 End { Case }
  End;

PROCEDURE Check4EqualSubtrees(T : PExpTree);
{      T     }
  Begin
    If (T^.Oper in ['-','/']) and IsEqualTree(T^.Left,T^.Right) then
      begin
        DeleteTree(T^.Left); DeleteTree(T^.Right);
        T^.Tip := Constant;
        Case T^.Oper of
          '-' : T^.Cons := 0;
          '/' : T^.Cons := 1
        End { Case }
      end
  End;

PROCEDURE SimpleMore(Var T : PExpTree);
{       
   (T+0)-->T, (T-0)-->T, (T*1)-->T, (T*0)-->0, (0/T)-->0, (T/1)-->T
   (0+T)-->T           , (1*T)-->T, (0*T)-->0
 :
   (T-T)-->0, (T/T)-->1
      . }

  Begin
    If T <> nil then
      With T^ do
        begin
          SimpleMore(Left); SimpleMore(Right);
          If Tip = Operator then
            Case Oper of
              '+' : If Equal(Left,0) then ClearLeft(T)
                    else If Equal(Right,0) then ClearRight(T);
              '-' : If Equal(Right,0) then ClearRight(T);
              '*' : If Equal(Left,0) or Equal(Right,0) then Clear(T)
                    else If Equal(Left,1) then ClearLeft(T)
                    else If Equal(Right,1) then ClearRight(T);
              '/' : If Equal(Left,0) then Clear(T)
                    else If Equal(Right,1) then ClearRight(T);
            End; { Case }
          Check4Consts(T);
          Check4EqualSubtrees(T)
        end
  End;


{ 
       ,     
   }

PROCEDURE CreateCopy(Tree : PExpTree; Var CTree : PExpTree);
  {     Tree     CTree }
  Begin
    If Tree = nil then CTree := nil
    else
      begin
        New(CTree); CTree^ := Tree^;
        CreateCopy(Tree^.Left,CTree^.Left);
        CreateCopy(Tree^.Right,CTree^.Right)
      end
  End;

FUNCTION Differ(T : PExpTree) : PExpTree;
  {  ,    }
Var P,Q,R : PExpTree;
  Begin
    If T = nil then Differ := nil
    else
      With T^ do
        Case Tip of
          Constant : Cons := 0; {     0 }
          Variable : begin Tip := Constant; Cons := 1 end; { x' = 1 }
          Operator :
             Case Oper of
               '+','-' : { (a+b)' = a'+b'; (a-b)' = a'-b' }
               begin Left := Differ(Left); Right := Differ(Right) end;
               '*' : begin { (a*b)' = a'*b + b'*a }
                       New(P); New(Q); Oper := '+';
                       {       T
                            (a'*b + b'*a)  }
                       P^.Tip := Operator; P^.Oper := '*';
                       Q^.Tip := Operator; Q^.Oper := '*';
                       CreateCopy(Left,P^.Left); CreateCopy(Right,Q^.Right);
                       P^.Right := Differ(Right); Q^.Left := Differ(Left);
                       Left := Q; Right := P
                     end;
               '/' : begin { (a/b)' = (a'*b - b'*a) / (b*b) }
                       {     , ..  b }
                       CreateCopy(Right,Q);

                       {    ,  
                            ,
                         ..   (a'*b - b'*a),   T }
                       Oper := '*'; T := Differ(T); Oper := '-';

                       {   (b*b),   P }
                       New(P); P^.Tip := Operator; P^.Oper := '*';
                       P^.Left := Q; CreateCopy(Q,P^.Right);

                       {   ,   T }
                       New(R); R^.Tip := Operator; R^.Oper := '/';
                       R^.Left := T; R^.Right := P; T := R
                     end;
             End { Case Oper }
        End; { Case Tip }
     Differ := T
  End;

{ 
      .  
   }

PROCEDURE Wait4Enter;
  Begin WriteLn(' <ENTER>,   ...');
        Repeat Until ReadKey = #13 End;

VAR S : String;
    P : PExpTree;
    X : TConstType;

BEGIN
  Write(',      x: '); ReadLn(S);
  BuildTree(S,P);
  Write(',     x: '); ReadLn(X);
  WriteLn('    x = ',X,' : ', Calculate(P,X));
  Wait4Enter;
  WriteLn('  ,   90 :'); PrintTree(P,0);
  Wait4Enter;
  WriteLn(',   :'); PrintExpr(P); WriteLn;
  Wait4Enter;
  WriteLn('  ,     :'); ShowTree(P);
  Wait4Enter;
  WriteLn('  :'); Simple(P); ShowTree(P);
  Wait4Enter;
  WriteLn('  :'); P := Differ(P); ShowTree(P);
  Wait4Enter;
  WriteLn('-2   :'); SimpleMore(P); ShowTree(P)
END.