{ 
               POST2PRE.PAS                                    
                     ,                                  
               BP 7.0                                          
  
                -  
                            ,   .   
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+}
{$M 65520,0,655360}

PROGRAM Prefix2Postfix;
TYPE PTree = ^TTree;
     TTree = Record
       Left, Right : PTree;
       Case Oper : Boolean of
         True  : (Op : Char);
         False : (Prom : Char)
     End;
Var Stack : Array[Byte] of PTree;

FUNCTION CreateTree(Op : Char; L,R : PTree) : PTree;
  {     Op,   L   - R }
Var P : PTree;
  Begin
    New(P); P^.Left := L; P^.Right := R; P^.Oper := L <> nil; P^.Op := Op;
    CreateTree := P
  End;

PROCEDURE Postfix2Tree(S : String; Var Tree : PTree; Var Error : Boolean);
  {    ,     }
Var I,Ind : Byte;
    P : PTree;
  Begin
    Tree := nil; Ind := 0; Error := False;
    For I := 1 to Length(S) do
      Case S[I] of
        'a'..'z','A'..'Z':begin Inc(Ind); Stack[Ind]:=CreateTree(S[I],nil,nil) end;
        '+','-','*','/' :
           begin
             If Ind < 2 then begin Error := True; Exit end;
             Dec(Ind); Stack[Ind] := CreateTree(S[I],Stack[Ind],Stack[Ind+1]);
           end
        else begin Error := True; Exit end;
      End;
    If Ind <> 1 then Error := True else Tree := Stack[1]
  End;

PROCEDURE Prefix2Tree(S : String; Var Tree : PTree; Var Error : Boolean);
  {    ,     }
Var I,Ind : Byte;
    P : PTree;
  Begin
    Tree := nil; Ind := 0; Error := False;
    For I := Length(S) downto 1 do
      Case S[I] of
        'a'..'z','A'..'Z':begin Inc(Ind); Stack[Ind]:=CreateTree(S[I],nil,nil) end;
        '+','-','*','/' :
           begin
             If Ind < 2 then begin Error := True; Exit end;
             Dec(Ind); Stack[Ind] := CreateTree(S[I],Stack[Ind+1],Stack[Ind]);
           end
        else begin Error := True; Exit end;
      End;
    If Ind <> 1 then Error := True else Tree := Stack[1]
  End;

PROCEDURE PrintInfix(P : PTree); {      }
  Procedure PrintSkoba(P : PTree); {  ,    }
    Begin
      If P^.Oper and (P^.Op in ['+','-']) then
        begin Write('('); PrintInfix(P); Write(')') end
      else PrintInfix(P)
    End;
  Begin
    If not P^.Oper then Write(P^.Prom)
    else If P^.Op in ['*','/'] then
         begin PrintSkoba(P^.Left); Write(P^.Op); PrintSkoba(P^.Right) end
    else begin PrintInfix(P^.Left); Write(P^.Op); PrintInfix(P^.Right) end
  End;

PROCEDURE PrintPostfix(P : PTree); {      }
  Begin
    If not P^.Oper then Write(P^.Prom)
    else begin PrintPostfix(P^.Left); PrintPostfix(P^.Right); Write(P^.Op) end
  End;

PROCEDURE PrintPrefix(P : PTree); {      }
  Begin
    If not P^.Oper then Write(P^.Prom)
    else begin Write(P^.Op); PrintPrefix(P^.Left); PrintPrefix(P^.Right) end
  End;

VAR Tree : PTree;
    S : String;
    Error : Boolean;
BEGIN
  WriteLn;
  S := 'ab+c*defhk/*u-++-';
  Postfix2Tree(S,Tree,Error);
  WriteLn('   ',S);
  WriteLn('=============================================');
  Write(' : '); PrintPrefix(Tree); WriteLn;
  Write(' : '); PrintInfix(Tree); WriteLn;
  Write(' : '); PrintPostfix(Tree); WriteLn;

  WriteLn;
  S := '/*+ab-cde';
  Prefix2Tree(S,Tree,Error);
  WriteLn('   ',S);
  WriteLn('=============================================');
  Write(' : '); PrintPrefix(Tree); WriteLn;
  Write(' : '); PrintInfix(Tree); WriteLn;
  Write(' : '); PrintPostfix(Tree); WriteLn
END.