{ 
               HEAPU.PAS                                       
                     ,                                  
               BP 7.0                                          
  
               .                     
  
                    "   "                    
   }

UNIT HeapU;

INTERFACE

CONST Max      = 1000;
TYPE  OGR      = 0..Max;
      DataType = Integer;
      THeap    = Record
                    Data  : Array[OGR] of DataType;
                    Count : OGR
                  End;

PROCEDURE AdjustDown(Var Heap : THeap);{      }
PROCEDURE AdjustUp(Var Heap : THeap; CurInd : Ogr);
                                    {      }
PROCEDURE BuildHeap(Var Heap : THeap);                      {   }
PROCEDURE BuildHeapArr(Var Heap : THeap);    {     Heap }
PROCEDURE CreateEmptyHeap(Var Heap : THeap);       {    }
FUNCTION  Delete(Var Heap : THeap) : DataType;{     }
PROCEDURE HeapSort(Var Heap : THeap);      {    }
PROCEDURE Insert(Var Heap : THeap; Dat : DataType);     {    }
FUNCTION  IsEmptyHeap(Heap : THeap) : Boolean;{     }
FUNCTION  IsFullHeap(Heap : THeap) : Boolean;  {     }
PROCEDURE SortHeap(Var Heap : THeap);     {    }


IMPLEMENTATION

PROCEDURE CreateEmptyHeap(Var Heap : THeap); {    }
  Begin Heap.Count := 0 End;

FUNCTION IsEmptyHeap(Heap : THeap) : Boolean; {     }
  Begin IsEmptyHeap := (Heap.Count = 0) End;

FUNCTION IsFullHeap(Heap : THeap) : Boolean; {     }
  Begin IsFullHeap := (Heap.Count = Max) End;

PROCEDURE AdjustUp(Var Heap : THeap; CurInd : Ogr);
{      }
Var Parent : OGR;
    Save   : DataType;
  Begin
    With Heap do
      begin
        Save := Data[CurInd];
        Parent := CurInd div 2; {    }
        While Parent >= 1 do
          begin
            If Save > Data[Parent] then {      }
              begin Data[CurInd] := Data[Parent]; CurInd := Parent end;
            Parent := Parent div 2
          end;
        Data[CurInd] := Save {       }
      end
  End;

PROCEDURE AdjustDown(Var Heap : THeap);{      }
Var Child, Parent : OGR;
    Save : DataType;
  Begin
    With Heap do
      begin
        {  }
        Parent := 1; Save := Data[1]; Child := 2;
        While Child <= Count do
          begin
            If Child+1 <= Count then {  -  }
              If Data[Child+1] > Data[Child] then Inc(Child);
            If Save < Data[Child] then
              begin {      }
                Data[Parent] := Data[Child];
                Parent := Child; Child := Child*2
              end
            else Break
          end;
        Data[Parent] := Save {       }
      end
  End;

PROCEDURE Insert(Var Heap : THeap; Dat : DataType); {    }
  Begin
    With Heap do
      begin Inc(Count); Data[Count] := Dat; AdjustUp(Heap,Count) end
  End;

FUNCTION Delete(Var Heap : THeap) : DataType; {     }
Var Save : DataType;
  Begin
    With Heap do
      begin
        Save := Data[1]; Data[1] := Data[Count]; Dec(Count);
        AdjustDown(Heap)
      end
  End;

PROCEDURE BuildHeap(Var Heap : THeap); {   }
Var Data : DataType;
  Begin
    CreateEmptyHeap(Heap);
    While not Eof do begin ReadLn(Data); Insert(Heap,Data) end
  End;

PROCEDURE BuildHeapArr(Var Heap : THeap); {     Heap }
Var I : OGR;
  Begin
    For I := 2 to Heap.Count do
      AdjustUp(Heap,I)
  End;

PROCEDURE SortHeap(Var Heap : THeap); {    }
Var I, SaveCount : OGR;
  Begin
    With Heap do
      begin
        SaveCount := Count; {  ,  AdjustUp   }
        {  ,      . }
        For I := 1 to SaveCount-1 do
           With Heap do Data[Count+1] := Delete(Heap);
        Count := SaveCount
      end
  End;

PROCEDURE HeapSort(Var Heap : THeap); {    }
  Begin
    BuildHeapArr(Heap);
    SortHeap(Heap)
  End;

END.