{ 
               LISTU.PAS                                       
                     ,                                  
               BP 7.0                                          
  
                 . 
  
                    "   "                    
   }

{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
UNIT LISTu;
INTERFACE
TYPE DataType = Integer;
     PList = ^TList;
     TList = Record
        Data : DataType;
        Next : PList
     End;

PROCEDURE CreateEmptyList(Var List : PList);         {    }
FUNCTION  IsEmpty(List : PList) : Boolean; {     }
PROCEDURE InsertFirst(Var List : PList; Data : DataType);
                                  {        }
PROCEDURE InsertAfter(Q : PList; Data : DataType);
                    {       ,   p }
PROCEDURE InsertBefore1(Var List : PList; Q : PList; Data : DataType);
                   {       ,   p }
PROCEDURE InsertBefore2(Q : PList; Data : DataType);
                   {       ,   p }
PROCEDURE DeleteFirst(Var List : PList);{      }
PROCEDURE DeleteAfter(Q : PList); {    ,   P }
PROCEDURE DeleteCurrent1(Var List : PList; Q : PList);
                                  {    ,   P }
PROCEDURE DeleteCurrent2(Q : PList);{   ,   P}
PROCEDURE Pass(List : PList);         {      }
PROCEDURE PrintList(List : PList); {       }
FUNCTION  GetLast(List : PList) : PList; {     }
FUNCTION  Find(List : PList; Data : DataType) : PList;
      {       Data    }
FUNCTION FindInsert(Var List : PList; Last : PList; Data : DataType) : PList;
         {         Data   ,
                    ,    -       }
PROCEDURE InvertList(Var List : PList);     {     }
PROCEDURE BuildInvertedList1(Var List : PList);    {    }
PROCEDURE BuildInvertedList2(Var List : PList);    {    }
PROCEDURE BuildList(Var List : PList);           {    }
PROCEDURE BuildSortedList(Var List : PList);{    }
PROCEDURE SortList(List : PList);          {      }
PROCEDURE DisposeList1(Var List : PList);{    }
PROCEDURE DisposeList2(Var List : PList);{    }


IMPLEMENTATION

PROCEDURE CreateEmptyList(Var List : PList); {    }
  Begin
     List := nil
  End;

FUNCTION IsEmpty(List : PList) : Boolean; {      }
  Begin
    IsEmpty := (List = nil)
  End;

PROCEDURE InsertFirst(Var List : PList; Data : DataType);
  {        }
Var P : PList;
  Begin
     New(P);
     P^.data := Data;
     P^.next := List;
     List := P
  End;

PROCEDURE InsertAfter(Q : PList; Data : DataType);
  {       ,   p }
Var P : PList;
  Begin
     New(P);
     P^.data := Data;
     P^.next := Q^.next;
     Q^.next := P
  End;

PROCEDURE InsertBefore1(Var List : PList; Q : PList; Data : DataType);
  {       ,   p }
Var P : PList;
  Begin
     If Q = List then InsertFirst(List,Data)
     else
       begin
          P := List;
          While P^.next <> Q do
            P := P^.next;
          InsertAfter(P,Data)
       end
  End;

PROCEDURE InsertBefore2(Q : PList; Data : DataType);
  {       ,   p }
Var P : PList;
  Begin
     New(P);
     P^ := Q^;
     Q^.data := Data;
     Q^.next := P
  End;

PROCEDURE DeleteFirst(Var List : PList);{      }
Var P : PList;
  Begin
     If not IsEmpty(List) then
       begin
          P := List;
          List := List^.next;
          Dispose(P)
       end
  End;

PROCEDURE DeleteAfter(Q : PList); {    ,   P }
Var P : PList;
  Begin
     If Q^.next <> nil then
       begin
          P := Q^.next;
          Q^.next := Q^.next^.next;
          Dispose(P)
       end
  End;

PROCEDURE DeleteCurrent1(Var List : PList; Q : PList);
  {    ,   P }
Var P : PList;
  Begin
     If Q <> List then DeleteFirst(List)
     else
       begin
          P := List;
          While P^.next <> Q do
            P := P^.next;
          DeleteAfter(P)
       end
  End;

PROCEDURE DeleteCurrent2(Q : PList);{   ,   P}
Var P : PList;
  Begin
     P := Q^.next;
     If Q <> nil then
       begin
         Q^ := P^;
         Dispose(P)
       end
  End;

PROCEDURE Pass(List : PList); {      }
  Procedure Operation(Data : DataType); Begin End; {   }
Var P : PList;
  Begin
     P := List;
     While P <> nil do
       begin
          Operation(P^.data);
          P := P^.next
       end
  End;

PROCEDURE PrintList(List : PList); {       }
  Begin
     While List <> nil do
       begin
          WriteLn(List^.data);
          List := List^.next
       end
  End;

PROCEDURE InvertList(Var List : PList); {     }
Var P,Q : PList;
  Begin
     P := nil;
     While List <> nil do
       begin
         Q := List^.next;
         List^.next := P;
         P := List;
         List := Q
       end;
     List := P
  End;

FUNCTION Find(List : PList; Data : DataType) : PList;
  {       Data    }
  Begin
    While (List <> nil) and (List^.data <> Data) do
      List := List^.next;
    Find := List
  End;

FUNCTION Found(List : PList; Data : DataType) : Boolean;
  {       Data }
  Begin
     Found := Find(List,Data) <> nil
  End;

PROCEDURE BuildInvertedList1(Var List : PList); {    }
Var Data : DataType;
  Begin
    CreateEmptyList(List);
    While not Eof do
      begin
        ReadLn(Data);
        InsertFirst(List,Data)
      end
  End;

PROCEDURE BuildInvertedList2(Var List : PList); {    }
Var P : PList;
  Begin
    List := nil;
    While not Eof do
      begin
         New(P);
         ReadLn(P^.data);
         P^.next := List;
         List := P
      end
  End;

PROCEDURE BuildList(Var List : PList); {    }
Var P,Tail : PList;
    Data : DataType;
  Begin
     ReadLn(Data); {    }
     New(P);
     P^.Data := Data;
     P^.next := nil;
     Tail := P; {    }
     While not Eof do
       begin
          ReadLn(Data);
          New(Tail^.next);
          Tail := Tail^.next;
          Tail^.data := Data;
          Tail^.next := nil
       end
  End;

PROCEDURE BuildSortedList(Var List : PList);{    }
Var P,Q,First : PList;
    Data : DataType;
  Begin
     New(List);
     ReadLn(List^.Data); {    }
     List^.next := nil;
     New(First); {       }
     First^.next := List;
     While not Eof do {     }
       begin
          P := First;
          List := P^.next;
          New(Q);
          ReadLn(Q^.data);
          While (List <> nil) and (List^.data < Q^.data) do
            begin
              P := List;
              List := List^.next
            end;
          Q^.next := List;
          P^.next := Q
       end
  End;

FUNCTION GetLast(List : PList) : PList; {      }
  Begin
     If List = nil then
        GetLast := nil
     else
       begin
         While List^.next <> nil do
           List := List^.next;
         GetLast := List
       end
  End;

PROCEDURE SortList(List : PList); {      }
Var Last,P,Q : PList;
    Data : DataType;
    Change : Boolean;
  Begin
     Last := nil;
     Repeat
        Change := False;
        P := List;
        While P^.next <> Last do
          begin
            If P^.data > P^.next^.data then
              begin
                 Data := P^.data;
                 P^.data := P^.next^.data;
                 P^.next^.data := Data;
                 Change := True
              end;
            Q := P;
            P := P^.next
          end;
        Last := Q
     Until not Change
  End;

PROCEDURE DisposeList1(Var List : PList);{    }
  Begin
     While not IsEmpty(List) do
       DeleteFirst(List)
  End;

PROCEDURE DisposeList2(Var List : PList);{    }
Var P : PList;
  Begin
     While List <> nil do
       begin
          P := List;
          List := List^.next;
          Dispose(P)
       end;
  End;

FUNCTION FindInsert(Var List : PList; Last : PList; Data : DataType) : PList;
{         Data   ,
   ,    -       }
Var P, Q : PList;
  Begin
     P := List;
     While P^.Data <> Data do
       P := P^.next;
     If P <> Last then
       If P^.next <> Last then
         begin
            Q := P^.next;
            P^ := Q^;
            Dispose(Q)
         end
       else
         begin
           Last := P;
           Dispose(P^.next)
         end;
     New(Q);
     Q^.data := Data;
     Q^.next := List;
     List := Q
  End;

END.