{ 
               TREEU.PAS                                       
                     ,                                  
               BP 7.0                                          
  
            ,      
                         : , , -  
                              .  .  
  
                    "   "                    
   }

UNIT TreeU;

INTERFACE

TYPE DataType = Integer;
     PTree = ^TTree;
     TTree = RECORD
        Data : DataType;
        Left, Right : PTree
     END;

PROCEDURE BuildTree(Var Tree : PTree);    {     }
FUNCTION  Count(Tree : PTree) : LongInt;     {     }
PROCEDURE CreateEmptyTree(Var Tree : PTree);          {    }
PROCEDURE CreateCopy(Tree : PTree; Var CTree : PTree);
                                     {       }
PROCEDURE Delete(Data : DataType; Var Tree : PTree);
                          {     Data    }
PROCEDURE DeleteTree(Var Tree : PTree);              {    }
FUNCTION  GetMaxLen(Tree : PTree) : LongInt;
                                  {      }
PROCEDURE InOrder(Tree : PTree);            {     "" }
FUNCTION  IsEmptyTree(Tree : PTree) : Boolean;   {     }
FUNCTION  IsEqualTree(Tree1,Tree2 : PTree) : Boolean;
                             {        }
PROCEDURE Mirror(Var Tree : PTree);{      }
PROCEDURE PostOrder(Tree : PTree);         {     "" }
PROCEDURE PreOrder(Tree : PTree);          {     "" }
PROCEDURE PrintTree(Tree : PTree; Len : Byte);
                         {      90   }
PROCEDURE PutInTree(Var Tree : PTree; Data : DataType);
                                {       Data }
FUNCTION  Search(Tree : PTree; Data : DataType) : PTree;
         {       Data     }

IMPLEMENTATION

PROCEDURE CreateEmptyTree(Var Tree : PTree); {    }
  Begin
     Tree := nil
  End;

FUNCTION IsEmptyTree(Tree : PTree) : Boolean; {     }
  Begin
     IsEmptyTree := Tree = nil
  End;

PROCEDURE PutInTree(Var Tree : PTree; Data : DataType);
 {       Data }
  Begin
     If Tree = nil then {      -  }
       begin
          Tree := New(PTree); Tree^.Data := Data;
          Tree^.Left := nil; Tree^.Right := nil
       end
    {         }
     else If Tree^.Data > Data then PutInTree(Tree^.Left,Data)
        {         }
          else If Tree^.Data < Data then PutInTree(Tree^.Right,Data)
  End;

PROCEDURE BuildTree(Var Tree : PTree); {     }
Var I : Byte;
  Begin
    Randomize;
    For I := 1 to 6 do PutInTree(Tree,Random(100));
    PutInTree(Tree,51)
  End;

PROCEDURE PrintTree(Tree : PTree; Len : Byte);
  {      90   }
Var I : Byte;
  Begin
     If Tree <> nil then
       begin
         PrintTree(Tree^.Left,Len+1);
         For I := 1 to Len do Write('   ');
         WriteLn(Tree^.Data);
         PrintTree(Tree^.Right,Len+1)
       end
  End;

FUNCTION Search(Tree : PTree; Data : DataType) : PTree;
 {       Data     }
Var Found : Boolean;
  Begin
     Found := False;
     While (Tree <> nil) and not Found do
       begin
         If Tree^.Data = Data then Found := True
         else If Tree^.Data > Data then Tree := Tree^.Left
                                   else Tree := Tree^.Right
       end;
     Search := Tree
  End;

PROCEDURE PreOrder(Tree : PTree); {     "" }
  Begin
    If Tree <> nil then
      begin
           Write(Tree^.Data:4);
         PreOrder(Tree^.Left);
         PreOrder(Tree^.Right)
      end
  End;

PROCEDURE InOrder(Tree : PTree); {     "" }
  Begin
    If Tree <> nil then
      begin
        InOrder(Tree^.Left);
          Write(Tree^.Data:4);
        InOrder(Tree^.Right)
      end
  End;

PROCEDURE PostOrder(Tree : PTree); {     "" }
  Begin
    If Tree <> nil then
      begin
        PostOrder(Tree^.Left);
        PostOrder(Tree^.Right);
          Write(Tree^.Data:4)
      end
  End;

FUNCTION IsEqualTree(Tree1,Tree2 : PTree) : Boolean;
  {        }
  Begin
    {      ,    }
    If (Tree1 = nil) and (Tree2 = nil) then IsEqualTree := True
    {        ,    }
    else If ((Tree1 <> nil) and (Tree2 = nil)) or
            ((Tree1 = nil) and (Tree2 <> nil)) then IsEqualTree := False
        {     ... }
         else If Tree1^.Data <> Tree2^.Data then IsEqualTree := False
              else IsEqualTree := IsEqualTree(Tree1^.Left, Tree2^.Left) and
                                  IsEqualTree(Tree1^.Right, Tree2^.Right)
  End;

PROCEDURE CreateCopy(Tree : PTree; Var CTree : PTree);
  {       }
  Begin
    If Tree = nil then CTree := nil
    else
      begin
        New(CTree);
        CTree^.Data := Tree^.Data;
        CreateCopy(Tree^.Left,CTree^.Left);
        CreateCopy(Tree^.Right,CTree^.Right)
      end
  End;

FUNCTION Count(Tree : PTree) : LongInt; {     }
  Begin
    If Tree = nil then Count := 0
    else Count := 1 + Count(Tree^.Left) + Count(Tree^.Right)
  End;

FUNCTION GetMaxLen(Tree : PTree) : LongInt;
  {      }
Var L,R : LongInt;
  Begin
    If Tree = nil then GetMaxLen := -1
    else
      begin
        L := GetMaxLen(Tree^.Left); R := GetMaxLen(Tree^.Right);
        If L > R then GetMaxLen := L+1 else GetMaxLen := R+1
      end
  End;

PROCEDURE DeleteTree(Var Tree : PTree); {    }
  Begin
    If Tree <> nil then
      begin
        DeleteTree(Tree^.Left);
        DeleteTree(Tree^.Right);
        Dispose(Tree);
        Tree := nil
      end
  End;

PROCEDURE Mirror(Var Tree : PTree);{       }

  Procedure Swap(Var P,Q : PTree); {    P  Q }
  Var S : PTree;
     Begin S := P; P := Q; Q := S End;

  Begin
    If Tree <> nil then
      begin
        Mirror(Tree^.Left);
        Mirror(Tree^.Right);
        Swap(Tree^.Left,Tree^.Right)
      end
  End;

PROCEDURE Delete(Data : DataType; Var Tree : PTree);
  {     Data    }
Var Q : PTree;

  Procedure Del(Var R : PTree);
    Begin
      If R^.Right <> nil then Del(R^.Right)
      else begin Q^.Data := R^.Data; Q := R; R := R^.Left end
    End;

  Begin
    If Tree = nil then WriteLn('     !')
    else If Data < Tree^.Data then Delete(Data,Tree^.Left)
       else If Data > Tree^.Data then Delete(Data,Tree^.Right)
          else
            begin
               Q := Tree;
               If Q^.Left = nil then Tree := Tree^.Right
               else If Q^.Right = nil then Tree := Tree^.Left
                    else Del(Tree^.Left);
               Dispose(Q)
            end
  End;

END.