{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,0,655360}
{ 
               GRAPHU.PAS                                      
                     ,                                  
               BP 7.0                                          
  
                .
  
                    "   "                    
   }

UNIT GraphU;

INTERFACE

CONST Oriented   = True;
      MultiGraph = True;

TYPE DataType = Integer;
     PVzel  = ^TVzel;
     PRebro = ^TRebro;
     TVzel  = Record
                Poseten    : Boolean;
                Num, Labl  : Word;
                Data       : DataType;
                Pred, Next : PVzel;
                Nasl       : PRebro
              End;
     TRebro = Record
                Next : PRebro;
                Vz   : PVzel
              End;
     PQueue = ^TQueue;
     TQueue = Record
                Data : PVzel;
                Next : PQueue
              End;
     PStack = PQueue; {         }

PROCEDURE AddRebro(Var Head,Tail : PVzel; X,Y : DataType; Multi : Boolean);
                                                     {     }
PROCEDURE BuildEmptyGraph(Var Head,Tail : PVzel);  {    }
PROCEDURE BuildGraph(Var Head,Tail : PVzel; Oriented : Boolean);
                                             {  ()  }
PROCEDURE BuildMultiGraph(Var Head,Tail : PVzel; Oriented,Multi : Boolean);
                                      {  () () }
FUNCTION  Find(Head,Tail : PVzel; Data : DataType) : PVzel;
                                     {         }
FUNCTION  FoundRebro(Head,Tail : PVzel; X,Y : DataType) : Boolean;
                           {       (X,Y) }
FUNCTION  FoundVzel(Head,Tail : PVzel; Data : DataType) : Boolean;
                {          }
FUNCTION  IsEmptyGraph(Head,Tail : PVzel) : Boolean;
                                          {      }
FUNCTION  Locate(Var Head,Tail : PVzel; Data : DataType) : PVzel;
                                  {   ,      }
PROCEDURE Naslednici(Head,Tail : PVzel);
                                 {       }
PROCEDURE Pass(Head,Tail : PVzel);
     {           }
PROCEDURE RemoveRebro(Head,Tail : PVzel; X,Y : DataType);
                                                  {     }
PROCEDURE RemoveRebro2(Head,Tail, PX,PY : PVzel);
                                        {   (PX,PY)   }
PROCEDURE RemoveVzel(Var Head,Tail,PP : PVzel);
                                                  {     }


{        }
PROCEDURE PushQ(Var QHead,QTail : PQueue; PVz : PVzel);
                                                {     }
FUNCTION  PopQ(Var QHead : PQueue) : PVzel;   {     }

{        }
PROCEDURE Push(Var Stack : PStack; Data : PVzel);      {    }
FUNCTION  Pop(Var Stack : PStack) : PVzel;       {     }
FUNCTION  Get(Stack : PStack) : PVzel;{       }

IMPLEMENTATION

{ ******************************************************************** }
{ ***           PVzel *** }
{ ******************************************************************** }

PROCEDURE PushQ(Var QHead,QTail : PQueue; PVz : PVzel);
  {     }
Var Q : PQueue;
  Begin
    PVz^.Poseten := True;
    If QHead = nil then
      begin New(QHead); QHead^.Next := nil; QHead^.Data:=PVz; QTail:=QHead end
    else
      begin New(QTail^.Next); QTail := QTail^.Next; Qtail^.Data := PVz;
            QTail^.Next := nil end
  End;

FUNCTION PopQ(Var QHead : PQueue) : PVzel; {     }
Var Q : PQueue;
  Begin
    If QHead <> nil then
      begin Q := QHead; QHead := QHead^.Next; PopQ := Q^.Data; Dispose(Q) end
  End;

{ ******************************************************************** }
{ ***           PVzel *** }
{ ******************************************************************** }

PROCEDURE Push(Var Stack : PStack; Data : PVzel); {    }
Var P : PStack;
  Begin New(P); P^.data := Data; P^.next := Stack; Stack := P End;

FUNCTION Pop(Var Stack : PStack) : PVzel; {     }
Var P : PStack;
  Begin
    If Stack <> nil then
      begin P:=Stack; Pop := Stack^.data; Stack := Stack^.next; Dispose(P) end
  End;

FUNCTION Get(Stack : PStack) : PVzel; {       }
  Begin
    If Stack <> nil then Get := Stack^.data
  End;

              { ******************************************** }
              { ******************************************** }
              { ******************************************** }
              { ***       *** }
              { ******************************************** }
              { ******************************************** }
              { ******************************************** }

PROCEDURE Pass(Head,Tail : PVzel);
  {           }
  Procedure Operation(PVz : PVzel); Begin Write(PVz^.Data,' ') End;
Var P : PVzel;
  Begin
    P := Head;
    While P <> Tail do
      begin Operation(P); P := P^.Next end
  End;

FUNCTION Find(Head,Tail : PVzel; Data : DataType) : PVzel;
  {         }
Var P : PVzel;
  Begin
    {   }
    Tail^.Data := Data; P := Head;
    While P^.Data <> Data do P := P^.Next;
    Find := P
  End;

FUNCTION FoundVzel(Head,Tail : PVzel; Data : DataType) : Boolean;
  {          }
Var P : PVzel;
  Begin
    FoundVzel := Find(Head,Tail,Data) <> Tail
  End;

FUNCTION Locate(Var Head,Tail : PVzel; Data : DataType) : PVzel;
  {   ,      }
Var P : PVzel;
  Begin
    P := Find(Head,Tail,Data);
    If P = Tail then
      begin Tail^.Nasl := nil; Tail^.Pred := nil; Tail^.Poseten := False;
            Tail^.Num := 0;
            P := Tail; Tail^.Next := New(PVzel); Tail := Tail^.Next end;
    Locate := P
  End;

FUNCTION IsEmptyGraph(Head,Tail : PVzel) : Boolean;
  {      }
  Begin
    IsEmptyGraph := (Tail = Head)
  End;

PROCEDURE BuildEmptyGraph(Var Head,Tail : PVzel); {    }
  Begin
    Head := New(PVzel); Tail := Head
  End;

FUNCTION FoundRebro(Head,Tail : PVzel; X,Y : DataType) : Boolean;
  {       (X,Y) }
Var PX,PY : PVzel;
    T : PRebro;
  Begin
    PX := Find(Head,Tail,X);
    If PX = nil then FoundRebro := False
    else
      begin
        T := PX^.Nasl;
        While (T <> nil) and (T^.Vz^.Data <> Y) do T := T^.next;
        FoundRebro := (T^.Vz^.Data = Y)
      end
  End;

PROCEDURE AddRebro(Var Head,Tail : PVzel; X,Y : DataType; Multi : Boolean);
  {     }
Var T     : PRebro;
    P,Q   : PVzel;
  Begin
    {    }
    P := Locate(Head,Tail,X);
    {      ,     }
    If X = Y then Exit;

    {         }
    T := P^.Nasl;
    While (T <> nil) and (T^.Vz^.Data <> Y) do
      T := T^.Next;
    {       }
    If (T = nil) or Multi then
      begin Q := Locate(Head,Tail,Y); T := New(PRebro);
            T^.Next := P^.Nasl; P^.Nasl := T; T^.Vz := Q end;
  End;

PROCEDURE RemoveRebro(Head,Tail : PVzel; X,Y : DataType);
                                  {   (X,Y)   }
Var T,T2 : PRebro;
    P    : PVzel;
  Begin
    {    }
    P := Find(Head,Tail,X); If P = nil then Exit;
    {             }
    T := P^.Nasl;
    While (T <> nil) and (T^.Vz^.Data<>Y) do begin T2 := T; T := T^.Next end;
    If T <> nil then
      If T = P^.Nasl then begin P^.Nasl := T^.Next; Dispose(T) end
      else begin T2^.next := T^.next; Dispose(T) end
  End;

PROCEDURE RemoveRebro2(Head,Tail,PX,PY : PVzel);
                                  {   (PX,PY)   }
Var T,T2 : PRebro;
  Begin
    {             }
    T := PX^.Nasl;
    While (T <> nil) and (T^.Vz <> PY) do begin T2 := T; T := T^.Next end;
    If T <> nil then
      If T = PX^.Nasl then begin PX^.Nasl := T^.Next; Dispose(T) end
      else begin T2^.next := T^.next; Dispose(T) end
  End;

PROCEDURE RemoveVzel(Var Head,Tail,PP : PVzel);
  {     }
Var P : PVzel;
  Begin
    {  ,   Data }
    P := Head;
    While P <> Tail do
      begin
        RemoveRebro2(Head,Tail,PP,P);
        RemoveRebro2(Head,Tail,P,PP);
        P := P^.Next
      end;
    {   Data }
    P := PP^.Next;
    If Tail = P then Tail := PP;
    PP^ := P^; Dispose(P)
  End;

PROCEDURE BuildGraph(Var Head,Tail : PVzel; Oriented : Boolean);
  {  ()  }
Var X,Y   : DataType;
  Begin
    BuildEmptyGraph(Head,Tail); {    }
    WriteLn(',         .');
    WriteLn('    .');
    {    }
    Write('(x,y) = '); ReadLn(X,Y);
    While (X <> 0) or (Y <> 0) do
      begin
        AddRebro(Head,Tail,X,Y,False);
        If not Oriented then AddRebro(Head,Tail,Y,X,False);
        Write('(x,y) = '); ReadLn(X,Y)
      end
  End;

PROCEDURE BuildMultiGraph(Var Head,Tail : PVzel; Oriented,Multi : Boolean);
  {  () () }
Var X,Y   : DataType;
  Begin
    BuildEmptyGraph(Head,Tail); {    }
    WriteLn(',         .');
    WriteLn('    .');
    {    }
    Write('(x,y) = '); ReadLn(X,Y);
    While (X <> 0) or (Y <> 0) do
      begin
        AddRebro(Head,Tail,X,Y,Multi);
        If not Oriented then AddRebro(Head,Tail,Y,X,Multi);
        Write('(x,y) = '); ReadLn(X,Y)
      end
  End;

PROCEDURE Naslednici(Head,Tail : PVzel);
  {       }
Var P : PVzel;
    T : PRebro;
  Begin
    P := Head;
    While P <> Tail do
      begin
        WriteLn;
        If P^.Nasl = nil then Write(' ',P^.Data,'  !')
        else
          begin
            Write('   ',P^.Data,'  : '); T := P^.Nasl;
            While t<>nil do begin Write(T^.Vz^.Data,' '); T := T^.Next end
          end;
        P := P^.Next
      end
  End;

END.